﻿touchPlay_Saved = {}
TouchButtons = {}
NUM_ACTIONBAR_BUTTONS = 20
HowManyTouchs = 74

local page = 2 
local spell = 1 
local shift = 3 
local pet = 4 
local port = 5 
local bag = 6 
local buff = 7 
local debuff = 8 
local IDBiasPage = 20
local IDBiasPort = 26
local IDBiasBuff = 41
local IDBiasPet = 64
local IDBiasShapeshift = 74 
local IDKeyRing = 40
local IDCharacterPortrait = 27 
local HowManyPages = 6
local HowManyShapeshifts = nil

local function touchFrameOnShow()
	if this == CharacterFrame then
		CharacterFrame_OnShow()
	elseif this == SpellBookFrame then
		SpellBookFrame_OnShow()
	elseif this == TalentFrame then
		TalentFrame_OnShow()
	elseif this == QuestFrame then
		QuestFrame_OnShow();
	elseif this == QuestLogFrame then
		QuestLog_OnShow()
	elseif this == FriendsFrame then
		FriendsFrame_OnShow()
	elseif this == MerchantFrame then
		MerchantFrame_OnShow()
		PlaySound("igCharacterInfoOpen")
	elseif this == BattlefieldFrame then
		PlaySound("igCharacterInfoOpen");
		BattlefieldFrame_Update();
	elseif this == TradeFrame then
		TradeFrame_OnShow()
		PlaySound("igCharacterInfoOpen")
	elseif this == TradeSkillFrame then
		TradeSkillInputBox:SetNumber(1); 
		PlaySound("igCharacterInfoOpen");
	elseif this == CraftFrame then
		PlaySound("igCharacterInfoOpen")
	elseif this == InspectFrame then
		local touchFrame = CharacterFrame . touchFrame 
		InspectFrame_OnShow()
		CharacterFrame : ClearAllPoints()
		CharacterFrame : SetPoint( "CENTER" , this , "CENTER" , 0 , 0 )
		touchFrame : ClearAllPoints()
		touchFrame : SetPoint( "CENTER" , this , "CENTER" , 0 , 0 )
	elseif this == AuctionFrame then
		AuctionFrame_OnShow()
	elseif this == GuildRegistrarFrame then
		GuildRegistrar_OnShow()
		PlaySound("igQuestListOpen");
	elseif this == MacroFrame then
		MacroFrame_OnShow()
	elseif this == GossipFrame then
		PlaySound("igQuestListOpen"); 
		if ( StaticPopup_Visible("XP_LOSS") ) then 
			StaticPopup_Hide("XP_LOSS"); 
		end
	elseif this == TaxiFrame or this == BankFrame then
		PlaySound("igMainMenuOpen")
	elseif this == TabardFrame or this == PetStableFrame then
		PlaySound("igCharacterInfoOpen");
	elseif this == DressUpFrame then
		PlaySound("igCharacterInfoOpen");
		SetPortraitTexture(DressUpFramePortrait, "player");
	elseif this == GameTooltip or this == MailFrame then
	else
		ContainerFrame_OnShow()
	end
	this : ClearAllPoints()
	this : SetPoint( "CENTER" , this . touchFrame , "CENTER" , 0 , 0 )
end

local function touchFrameShowHide()
	if IsAltKeyDown() then 
		local touchFrame = this . touchFrame 
		if ( touchFrame . isMoving ) then 
			touchFrame : Hide()
			touchFrame . isMoving = false;
		else
			touchFrame : Show()
			touchFrame . isMoving = true;
		end
	end
end

local function touchFrameStop()
	local Movee = this . Movee 
	local Movee0 = this . Movee0 
	this : StopMovingOrSizing();
	this : Hide();
	this . isMoving = false;
	Movee : ClearAllPoints()
	Movee : SetPoint( "CENTER" , this , "CENTER" , 0 , 0 ) 
	if Movee0 then
		Movee0 : ClearAllPoints()
		Movee0 : SetPoint( "LEFT" , this , "LEFT" , 15 , 0 ) 
	end
end

local frameTime = 0
local function updateFukFrame()
	frameTime = frameTime + 1
	if frameTime == 60 then
		frameTime = 0
		PlayerFrame : ClearAllPoints()
		PlayerFrame : SetPoint( "CENTER" , touchPlayerFrame , "CENTER" , 0 , 0 ) 
		MainMenuBarPerformanceBarFrame : ClearAllPoints()
		MainMenuBarPerformanceBarFrame : SetPoint( "LEFT" , touchPlayerFrame , "LEFT" , 15 , 0 )
		TargetFrame : ClearAllPoints()
		TargetFrame : SetPoint( "CENTER" , touchTargetFrame , "CENTER" , 0 , 0 ) 
		if ( ClassTrainerFrame : IsVisible() ) then
			ClassTrainerFrame : ClearAllPoints()
			ClassTrainerFrame : SetPoint( "CENTER" , touchTrainerFrame , "CENTER" , 0 , 0 )
		end 
	end
end

local function touchButtonSetSize( touchButton , size , touchBar , touchID )
	if size == nil then
		size = 0
	end
	if touchBar == port then
		touchButton : SetWidth( size + 32 )
		touchButton : SetHeight( size *2 + 64 )
		if touchID == IDCharacterPortrait then
			MicroButtonPortrait : SetWidth( size*0.8 + 18 )
			MicroButtonPortrait : SetHeight( size*25/18*0.8 + 25 )
			MicroButtonPortrait : ClearAllPoints()
			MicroButtonPortrait : SetPoint( "TOP" , 0 , (size*1.7 * -28/58) -28 )
		end
	elseif touchBar == pet then
			local textSize = size * 0.2 + 10
			local cooldownSize = size *0.95 / 30 + 0.85
			local autoCastSize = size * 1.1 / 30 + 1.2
			local textureSize = size * 54 / 30 + 54
			local buttonSize = size + 30 
			local AutoCastable = touchButton . AutoCastable 
			local NormalTexture2 = touchButton . NormalTexture2 

			touchButton:SetWidth( buttonSize  )
			touchButton:SetHeight( buttonSize  )
			touchButton.HotKey:SetTextHeight( textSize )
			touchButton.Count:SetTextHeight( textSize )
			touchButton.Name:SetTextHeight( textSize )

			touchButton . Cooldown : SetScale( cooldownSize )
			touchButton . AutoCast : SetModelScale( autoCastSize )
			
			AutoCastable : SetWidth( textureSize );
			AutoCastable : SetHeight( textureSize );
			NormalTexture2 : SetWidth( textureSize )
			NormalTexture2 : SetHeight( textureSize )
	elseif touchBar == shift then
		local textSize = size * 0.2 + 10
		local cooldownSize = size * 0.8 / 30 + 0.8 
		local textureSize = size *54 / 30 +54
		local buttonSize = size + 30 
		local NormalTexture = touchButton . NormalTexture 

		touchButton:SetWidth( buttonSize  )
		touchButton:SetHeight( buttonSize  )
		NormalTexture : SetWidth( textureSize )
		NormalTexture : SetHeight( textureSize )
		touchButton.HotKey:SetTextHeight( textSize )
		touchButton.Count:SetTextHeight( textSize )
		touchButton.Name:SetTextHeight( textSize )

		touchButton . Cooldown : SetScale( cooldownSize )
	elseif touchBar == bag then
		if touchButton . TouchID == IDKeyRing then
			touchButton:SetWidth( size *0.5 + 18 )
			touchButton:SetHeight( size *39/36 + 39 )
		else
			local buttonSize = size + 37 
			local textureSize = size * 64 / 37 + 64 
			local NormalTexture = touchButton . NormalTexture 

			touchButton : SetWidth( buttonSize  )
			touchButton : SetHeight( buttonSize  )
			NormalTexture : SetWidth( textureSize )
			NormalTexture : SetHeight( textureSize )
		end
	elseif touchBar == buff then
		local buttonSize = size + 30 
		touchButton : SetWidth( buttonSize  )
		touchButton : SetHeight( buttonSize  )
	elseif touchBar == debuff then
		touchButton : SetScale( size * 0.05 + 1 )
	else
		local buttonSize = size + 36

		touchButton:SetWidth( buttonSize  )
		touchButton:SetHeight( buttonSize  )
		if touchBar == spell then
			local textSize = size * 0.2 + 10
			local cooldownSize = size * 0.75 / 36 + 0.7
			local textureSize = size * 64 / 36 + 64
			local circleSize = size * 100 / 36 + 100
			local cxscale = size * 20 / 36 + 20
			local cyscale = size * ( -22 / 36 ) -22
			local NormalTexture = touchButton . NormalTexture
			local Circle = touchButton . Circle

			touchButton.HotKey:SetTextHeight( textSize )
			touchButton.Count:SetTextHeight( textSize )
			touchButton.Name:SetTextHeight( textSize )
			touchButton.Cooldown:SetModelScale( cooldownSize )
			NormalTexture :SetWidth( textureSize )
			NormalTexture :SetHeight( textureSize )
			Circle :SetWidth( circleSize )
			Circle :SetHeight( circleSize )
			Circle : ClearAllPoints()
			Circle : SetPoint( "CENTER" , cxscale , cyscale )
		end
	end
end

local function touchButtonSliderChanging( slider , SizeText , touchBar , touchID )
	if not slider then
		slider = this
	end
	local idSlider = slider:GetID()
	local size = slider:GetValue()
	if idSlider == 0 then
		touchPlay_Saved[ touchID ] = size 
		getglobal( SizeText ):SetText( size )
		touchButtonSetSize( TouchButtons[ touchID ] , size , touchBar , touchID )
	elseif idSlider == 1 then
		getglobal( SizeText ):SetText( size )
		local prevAllSpellSize = touchPlay_Saved[ AllSpellSize ]
		touchPlay_Saved[ AllSpellSize ] = size
		if prevAllSpellSize  < size then
			prevAllSpellSize = size - prevAllSpellSize
			for n = spell , IDBiasPage do
				size = touchPlay_Saved[ n ] + prevAllSpellSize
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		else
			prevAllSpellSize = prevAllSpellSize - size
			for n = spell , IDBiasPage do
				size = touchPlay_Saved[ n ] - prevAllSpellSize
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		end
	elseif idSlider == 2 then
		getglobal( SizeText ):SetText( size )
		local prevPageSize = touchPlay_Saved[ PageSize ]
		touchPlay_Saved[ PageSize ] = size
		if prevPageSize < size then
			prevPageSize = size - prevPageSize 
			for n = IDBiasPage + 1 , IDBiasPort do
				size = touchPlay_Saved[ n ] + prevPageSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		else
			prevPageSize = prevPageSize - size
			for n = IDBiasPage + 1 , IDBiasPort do
				size = touchPlay_Saved[ n ] - prevPageSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		end
	elseif idSlider == 3 then
		getglobal( SizeText ):SetText( size )
		local prevBuffSize = touchPlay_Saved[ BuffSize ]
		touchPlay_Saved[ BuffSize ] = size
		if prevBuffSize < size then
			prevBuffSize = size - prevBuffSize 
			for n = IDBiasBuff , IDBiasBuff + 15 do
				size = touchPlay_Saved[ n ] + prevBuffSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		else
			prevBuffSize = prevBuffSize - size
			for n = IDBiasBuff , IDBiasBuff + 15 do
				size = touchPlay_Saved[ n ] - prevBuffSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		end
	elseif idSlider == 4 then
		getglobal( SizeText ):SetText( size )
		local prevDebuffSize = touchPlay_Saved[ DebuffSize ]
		touchPlay_Saved[ DebuffSize ] = size
		if prevDebuffSize < size then
			prevDebuffSize = size - prevDebuffSize 
			for n = IDBiasBuff + 16 , IDBiasPet do
				size = touchPlay_Saved[ n ] + prevDebuffSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		else
			prevDebuffSize = prevDebuffSize - size
			for n = IDBiasBuff + 16 , IDBiasPet do
				size = touchPlay_Saved[ n ] - prevDebuffSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		end
	elseif idSlider == 5 then
		getglobal( SizeText ):SetText( size )
		local prevBagSize = touchPlay_Saved[ BagSize ]
		touchPlay_Saved[ BagSize ] = size
		if prevBagSize < size then
			prevBagSize = size - prevBagSize 
			for n = IDKeyRing -5 , IDKeyRing do
				size = touchPlay_Saved[ n ] + prevBagSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		else
			prevBagSize = prevBagSize - size
			for n = IDKeyRing -5 , IDKeyRing do
				size = touchPlay_Saved[ n ] - prevBagSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		end
	elseif idSlider == 6 then
		getglobal( SizeText ):SetText( size )
		local prevGamePortSize = touchPlay_Saved[ GamePortSize ]
		touchPlay_Saved[ GamePortSize ] = size
		if prevGamePortSize < size then
			prevGamePortSize = size - prevGamePortSize 
			for n = IDCharacterPortrait , IDCharacterPortrait + 7 do
				size = touchPlay_Saved[ n ] + prevGamePortSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		else
			prevGamePortSize = prevGamePortSize - size
			for n = IDCharacterPortrait , IDCharacterPortrait + 7 do
				size = touchPlay_Saved[ n ] - prevGamePortSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		end
	elseif idSlider == 7 then
		getglobal( SizeText ):SetText( size )
		local prevPetSize = touchPlay_Saved[ PetSize ]
		touchPlay_Saved[ PetSize ] = size
		if prevPetSize < size then
			prevPetSize = size - prevPetSize 
			for n = IDBiasPet + 1 , IDBiasShapeshift do
				size = touchPlay_Saved[ n ] + prevPetSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		else
			prevPetSize = prevPetSize - size
			for n = IDBiasPet + 1 , IDBiasShapeshift do
				size = touchPlay_Saved[ n ] - prevPetSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		end
	elseif idSlider == 8 then
		getglobal( SizeText ):SetText( size )
		local prevShiftSize = touchPlay_Saved[ ShiftSize ]
		touchPlay_Saved[ ShiftSize ] = size
		if prevShiftSize < size then
			prevShiftSize = size - prevShiftSize 
			for n = IDBiasShapeshift + 1 , HowManyTouchs do
				size = touchPlay_Saved[ n ] + prevShiftSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		else
			prevShiftSize = prevShiftSize - size
			for n = IDBiasShapeshift + 1 , HowManyTouchs do
				size = touchPlay_Saved[ n ] - prevShiftSize 
				getglobal( TouchControl .. n .. Slider_SpellSize_Range ):SetValue( size  )
			end
		end
	elseif idSlider == 9 then
		getglobal( SizeText ):SetText( size )
		local prevAllSize = touchPlay_Saved[ AllSize ]
		touchPlay_Saved[ AllSize ] = size
		if prevAllSize < size then
			prevAllSize = size - prevAllSize 
			getglobal( TouchControlAll .. Slider_AllSpellSize_Range ):SetValue( touchPlay_Saved[ AllSpellSize ] + prevAllSize )
			getglobal( TouchControlAll .. Slider_PageSize_Rang ):SetValue( touchPlay_Saved[ PageSize ] + prevAllSize )
			getglobal( TouchControlAll .. Slider_BuffSize_Rang ):SetValue( touchPlay_Saved[ BuffSize ] + prevAllSize )
			getglobal( TouchControlAll .. Slider_DebuffSize_Rang ):SetValue( touchPlay_Saved[ DebuffSize ] + prevAllSize )
			getglobal( TouchControlAll .. Slider_BagSize_Rang ):SetValue( touchPlay_Saved[ BagSize ] + prevAllSize )
			getglobal( TouchControlAll .. Slider_GamePortSize_Range ):SetValue( touchPlay_Saved[ GamePortSize ] + prevAllSize )
			getglobal( TouchControlAll .. Slider_PetSize_Rang ):SetValue( touchPlay_Saved[ PetSize ] + prevAllSize )
			getglobal( TouchControlAll .. Slider_ShiftSize_Rang ):SetValue( touchPlay_Saved[ ShiftSize ] + prevAllSize )
		else
			prevAllSize = prevAllSize - size
			getglobal( TouchControlAll .. Slider_AllSpellSize_Range ):SetValue( touchPlay_Saved[ AllSpellSize ] -prevAllSize )
			getglobal( TouchControlAll .. Slider_PageSize_Rang ):SetValue( touchPlay_Saved[ PageSize ] -prevAllSize )
			getglobal( TouchControlAll .. Slider_BuffSize_Rang ):SetValue( touchPlay_Saved[ BuffSize ] -prevAllSize )
			getglobal( TouchControlAll .. Slider_DebuffSize_Rang ):SetValue( touchPlay_Saved[ DebuffSize ] -prevAllSize )
			getglobal( TouchControlAll .. Slider_BagSize_Rang ):SetValue( touchPlay_Saved[ BagSize ] -prevAllSize )
			getglobal( TouchControlAll .. Slider_GamePortSize_Range ):SetValue( touchPlay_Saved[ GamePortSize ] -prevAllSize )
			getglobal( TouchControlAll .. Slider_PetSize_Rang ):SetValue( touchPlay_Saved[ PetSize ] -prevAllSize )
			getglobal( TouchControlAll .. Slider_ShiftSize_Rang ):SetValue( touchPlay_Saved[ ShiftSize ] -prevAllSize )
		end
	end
end

local function touchButtonDraging()
	if IsControlKeyDown() then
		local touchControl = getglobal( TouchControl .. this : GetID() )
		if ( touchControl . isShowing == false ) then
			touchControl : Show();
			touchControl . isShowing = True;
		else
			touchControl : Hide();
			touchControl . isShowing = false ;
		end
	elseif IsAltKeyDown() then
		this : StartMoving();
		this . isMoving = true;
	elseif ( LOCK_ACTIONBAR ~= "1" ) then
		PickupAction(ActionButton_GetPagedID(this));
		ActionButton_UpdateState();
	end
end

local shiftTime = 0
local function updateShapeshiftButton()
	shiftTime = shiftTime + 1
	if shiftTime == 19 then
		this : SetScript( "OnUpdate" , nil )
		shiftTime = 0
		for n = 1 , HowManyShapeshifts do
			touchButtonSetSize( TouchButtons[ n + IDBiasShapeshift ] , touchPlay_Saved[ n + IDBiasShapeshift ] , shift )
		end
	end
end

local function DragStart_Frame()
	this:StartMoving(); 
	this.isMoving = true;
end

local function DragStop_Frame()
	this:StopMovingOrSizing();
	this.isMoving = false;
end

local function MouseUp_Frame()
	if ( this . isMoving ) then 
		this:StopMovingOrSizing();
		this . isMoving = false;
	end
end

local function DragStart_touchButton()
	if IsAltKeyDown() then 
		this:StartMoving(); 
		this.isMoving = true;
	elseif IsControlKeyDown() then
		local touchControl = nil
		local touchBar = this . touchBar 
		if touchBar == shift then
			touchControl = getglobal( TouchControl .. this:GetID() + IDBiasShapeshift )
		elseif touchBar == buff or touchBar == debuff then
			touchControl = getglobal( TouchControl .. this . TouchID )
		else
			touchControl = getglobal( TouchControl .. this:GetID() )
		end
		if ( touchControl . isShowing == false ) then
			touchControl:Show();
			touchControl . isShowing = True;
		else
			touchControl:Hide();
			touchControl . isShowing = false ;
		end
	elseif this . touchBar == shift then
		for n = 1 , HowManyShapeshifts do
			touchButtonSetSize( TouchButtons[ n + IDBiasShapeshift ] , touchPlay_Saved[ n + IDBiasShapeshift ] , shift )
		end
	end
end

local function DragStart_bagButton()
	if IsAltKeyDown() then 
		this:StartMoving(); 
		this.isMoving = true;
	elseif IsControlKeyDown() then
		local touchControl = getglobal( TouchControl .. this . TouchID )
		if ( touchControl . isShowing == false ) then
			touchControl:Show();
			touchControl . isShowing = True;
		else
			touchControl:Hide();
			touchControl . isShowing = false ;
		end
	elseif this == KeyRingButton or this == MainMenuBarBackpackButton then
	else
		PaperDollItemSlotButton_OnClick("LeftButton", 1);
		BagSlotButton_OnDrag();
	end
end

local function DragStart_petButton()
	if IsAltKeyDown() then 
		this:StartMoving(); 
		this.isMoving = true;
	elseif IsControlKeyDown() then
		local touchControl = getglobal( TouchControl .. this:GetID() + IDBiasPet )
		if ( touchControl . isShowing == false ) then
			touchControl:Show();
			touchControl . isShowing = True;
		else
			touchControl:Hide();
			touchControl . isShowing = false ;
		end
	else
		this:SetChecked(0);
		PickupPetAction(this:GetID());
	end
end

local function ReceiveDrag_petButton()
	if IsAltKeyDown() or IsControlKeyDown() then 
	else
		this:SetChecked(0);
		PickupPetAction(this:GetID());
	end
end

local function switchTouchButton( currentID )
	local touchButton = nil
	for pageID = 1 , HowManyPages do
		touchButton = TouchButtons[ pageID + IDBiasPage ]
		if pageID == currentID then
			this : SetNormalTexture( "Interface\\AddOns\\touchPlay\\Icon\\switchIcon" .. currentID .. "-Up" )
		else
			touchButton : SetNormalTexture( "Interface\\AddOns\\touchPlay\\Icon\\switchIcon" .. pageID .. "-Disabled" )
		end
	end
end

local function switchTouchBar()
	local currentID = this:GetID() -IDBiasPage --correct pageID
	switchTouchButton( currentID )
	CURRENT_ACTIONBAR_PAGE = currentID 
	PlaySound("UChatScrollButton");
	ChangeActionBarPage();
end

function init_Touch()
		local size = touchPlay_Saved[ AllSize ]
		if size == nil then
			touchPlay_Saved[ AllSize ] = 0
			size = 0
		end
	getglobal( TouchControlAll  .. Slider_AllSize_Rang .. "Text" ):SetText( TouchControlAllSizeSliderText )
	getglobal( TouchControlAll  .. Slider_AllSize_Rang .. "Low" ):SetText( "0" )
	getglobal( TouchControlAll  .. Slider_AllSize_Rang .. "High" ):SetText( "100" )
	getglobal( TouchControlAll  .. SliderText_AllSize ):SetText( size  )
	local sizeSlider = getglobal( TouchControlAll  .. Slider_AllSize_Rang )
	sizeSlider:SetMinMaxValues( 0 , 100 )
	sizeSlider:SetValueStep( 1 )
	sizeSlider:SetValue( size )
	sizeSlider.changing = touchButtonSliderChanging

		size = touchPlay_Saved[ AllSpellSize ]
		if size == nil then
			touchPlay_Saved[ AllSpellSize ] = 0
			size = 0
		end
	getglobal( TouchControlAll  .. Slider_AllSpellSize_Range .. "Text" ):SetText( TouchControlAllSpellSizeSliderText )
	getglobal( TouchControlAll  .. Slider_AllSpellSize_Range .. "Low" ):SetText( "0" )
	getglobal( TouchControlAll  .. Slider_AllSpellSize_Range .. "High" ):SetText( "100" )
	getglobal( TouchControlAll  .. SliderText_AllSpellSize ):SetText( size )
	sizeSlider = getglobal( TouchControlAll  .. Slider_AllSpellSize_Range )
	sizeSlider:SetMinMaxValues( 0 , 100 )
	sizeSlider:SetValueStep( 1 )
	sizeSlider:SetValue( size )
	sizeSlider.changing = touchButtonSliderChanging

		size = touchPlay_Saved[ PageSize ]
		if size == nil then
			touchPlay_Saved[ PageSize ] = 0
			size = 0
		end
	getglobal( TouchControlAll  .. Slider_PageSize_Rang .. "Text" ):SetText( TouchControlPageSizeSliderText )
	getglobal( TouchControlAll  .. Slider_PageSize_Rang .. "Low" ):SetText( "0" )
	getglobal( TouchControlAll  .. Slider_PageSize_Rang .. "High" ):SetText( "100" )
	getglobal( TouchControlAll  .. SliderText_PageSize ):SetText( size  )
	sizeSlider = getglobal( TouchControlAll  .. Slider_PageSize_Rang )
	sizeSlider:SetMinMaxValues( 0 , 100 )
	sizeSlider:SetValueStep( 1 )
	sizeSlider:SetValue( size )
	sizeSlider.changing = touchButtonSliderChanging

		size = touchPlay_Saved[ BuffSize ]
		if size == nil then
			touchPlay_Saved[ BuffSize ] = 0
			size = 0
		end
	getglobal( TouchControlAll  .. Slider_BuffSize_Rang .. "Text" ):SetText( TouchControlBuffSizeSliderText )
	getglobal( TouchControlAll  .. Slider_BuffSize_Rang .. "Low" ):SetText( "0" )
	getglobal( TouchControlAll  .. Slider_BuffSize_Rang .. "High" ):SetText( "100" )
	getglobal( TouchControlAll  .. SliderText_BuffSize ):SetText( size  )
	sizeSlider = getglobal( TouchControlAll  .. Slider_BuffSize_Rang )
	sizeSlider:SetMinMaxValues( 0 , 100 )
	sizeSlider:SetValueStep( 1 )
	sizeSlider:SetValue( size )
	sizeSlider.changing = touchButtonSliderChanging

		size = touchPlay_Saved[ DebuffSize ]
		if size == nil then
			touchPlay_Saved[ DebuffSize ] = 0
			size = 0
		end
	getglobal( TouchControlAll  .. Slider_DebuffSize_Rang .. "Text" ):SetText( TouchControlDebuffSizeSliderText )
	getglobal( TouchControlAll  .. Slider_DebuffSize_Rang .. "Low" ):SetText( "0" )
	getglobal( TouchControlAll  .. Slider_DebuffSize_Rang .. "High" ):SetText( "100" )
	getglobal( TouchControlAll  .. SliderText_DebuffSize ):SetText( size  )
	sizeSlider = getglobal( TouchControlAll  .. Slider_DebuffSize_Rang )
	sizeSlider:SetMinMaxValues( 0 , 100 )
	sizeSlider:SetValueStep( 1 )
	sizeSlider:SetValue( size )
	sizeSlider.changing = touchButtonSliderChanging

		size = touchPlay_Saved[ BagSize ]
		if size == nil then
			touchPlay_Saved[ BagSize ] = 0
			size = 0
		end
	getglobal( TouchControlAll  .. Slider_BagSize_Rang .. "Text" ):SetText( TouchControlBagSizeSliderText )
	getglobal( TouchControlAll  .. Slider_BagSize_Rang .. "Low" ):SetText( "0" )
	getglobal( TouchControlAll  .. Slider_BagSize_Rang .. "High" ):SetText( "100" )
	getglobal( TouchControlAll  .. SliderText_BagSize ):SetText( size  )
	sizeSlider = getglobal( TouchControlAll  .. Slider_BagSize_Rang )
	sizeSlider:SetMinMaxValues( 0 , 100 )
	sizeSlider:SetValueStep( 1 )
	sizeSlider:SetValue( size )
	sizeSlider.changing = touchButtonSliderChanging

		size = touchPlay_Saved[ GamePortSize ]
		if size == nil then
			touchPlay_Saved[ GamePortSize ] = 0
			size = 0
		end
	getglobal( TouchControlAll  .. Slider_GamePortSize_Range .. "Text" ):SetText( TouchControlGamePortSizeSliderText )
	getglobal( TouchControlAll  .. Slider_GamePortSize_Range .. "Low" ):SetText( "0" )
	getglobal( TouchControlAll  .. Slider_GamePortSize_Range .. "High" ):SetText( "100" )
	getglobal( TouchControlAll  .. SliderText_GamePortSize ):SetText( size  )
	sizeSlider = getglobal( TouchControlAll  .. Slider_GamePortSize_Range )
	sizeSlider:SetMinMaxValues( 0 , 100 )
	sizeSlider:SetValueStep( 1 )
	sizeSlider:SetValue( size )
	sizeSlider.changing = touchButtonSliderChanging

		size = touchPlay_Saved[ PetSize ]
		if size == nil then
			touchPlay_Saved[ PetSize ] = 0
			size = 0
		end
	getglobal( TouchControlAll  .. Slider_PetSize_Rang .. "Text" ):SetText( TouchControlPetSizeSliderText )
	getglobal( TouchControlAll  .. Slider_PetSize_Rang .. "Low" ):SetText( "0" )
	getglobal( TouchControlAll  .. Slider_PetSize_Rang .. "High" ):SetText( "100" )
	getglobal( TouchControlAll  .. SliderText_PetSize ):SetText( size  )
	sizeSlider = getglobal( TouchControlAll  .. Slider_PetSize_Rang )
	sizeSlider:SetMinMaxValues( 0 , 100 )
	sizeSlider:SetValueStep( 1 )
	sizeSlider:SetValue( size )
	sizeSlider.changing = touchButtonSliderChanging

		size = touchPlay_Saved[ ShiftSize ]
		if size == nil then
			touchPlay_Saved[ ShiftSize ] = 0
			size = 0
		end
	getglobal( TouchControlAll  .. Slider_ShiftSize_Rang .. "Text" ):SetText( TouchControlShiftSizeSliderText )
	getglobal( TouchControlAll  .. Slider_ShiftSize_Rang .. "Low" ):SetText( "0" )
	getglobal( TouchControlAll  .. Slider_ShiftSize_Rang .. "High" ):SetText( "100" )
	getglobal( TouchControlAll  .. SliderText_ShiftSize ):SetText( size  )
	sizeSlider = getglobal( TouchControlAll  .. Slider_ShiftSize_Rang )
	sizeSlider:SetMinMaxValues( 0 , 100 )
	sizeSlider:SetValueStep( 1 )
	sizeSlider:SetValue( size )
	sizeSlider.changing = touchButtonSliderChanging

	local touchControl = nil
	local touchUnitClass = UnitClass("player")
	if touchUnitClass == touchWarrior then
		HowManyTouchs = 77
		HowManyShapeshifts = 3
		getglobal( TouchControlAll .. Slider_ShiftSize_Rang ) : Show()
		getglobal( TouchControlAll .. "ShiftLinkV" ) : Show()
		getglobal( TouchControlAll .. "ShiftLinkH" ) : Show()
		getglobal( TouchControlAll .. SliderText_ShiftSize ) : Show()
	elseif touchUnitClass == touchPaladin then
		HowManyTouchs = 81
		HowManyShapeshifts = 7
		getglobal( TouchControlAll .. Slider_ShiftSize_Rang ) : Show()
		getglobal( TouchControlAll .. "ShiftLinkV" ) : Show()
		getglobal( TouchControlAll .. "ShiftLinkH" ) : Show()
		getglobal( TouchControlAll .. SliderText_ShiftSize ) : Show()
	elseif touchUnitClass == touchRogue then
		HowManyTouchs = 75
		HowManyShapeshifts = 1
		getglobal( TouchControlAll .. Slider_ShiftSize_Rang ) : Show()
		getglobal( TouchControlAll .. "ShiftLinkV" ) : Show()
		getglobal( TouchControlAll .. "ShiftLinkH" ) : Show()
		getglobal( TouchControlAll .. SliderText_ShiftSize ) : Show()
	elseif touchUnitClass == touchDruid then
		HowManyTouchs = 79
		HowManyShapeshifts = 5
		getglobal( TouchControlAll .. Slider_ShiftSize_Rang ) : Show()
		getglobal( TouchControlAll .. "ShiftLinkV" ) : Show()
		getglobal( TouchControlAll .. "ShiftLinkH" ) : Show()
		getglobal( TouchControlAll .. SliderText_ShiftSize ) : Show()
	end
	for n = 1 , HowManyTouchs do
		size = touchPlay_Saved[ n ]
		if size ~= nil then
		else
			touchPlay_Saved[ n ] = 0
			size = 0
		end
		touchControl = CreateFrame( "Frame" , TouchControl .. n , UIParent , "touchControlTemplate" , n )
		touchControl : SetID( n )
		sizeSlider = {
				TouchControl .. n .. SliderText_TouchControlHeader ,
				TouchControl .. n .. Slider_SpellSize_Range .. "Text" ,
				TouchControl .. n .. Slider_SpellSize_Range .. "Low" ,
				TouchControl .. n .. Slider_SpellSize_Range .. "High" ,
				TouchControl .. n .. SliderText_SpellSize ,
				TouchControlHeaderText .. n ,
				TouchControlSizeSliderText ,
				"0" ,
				"100" ,
				size 
				}
		for count = 1 , 5 do
			getglobal( sizeSlider[ count ] ):SetText( sizeSlider[ count + 5 ] )
		end

		sizeSlider = getglobal( TouchControl .. n .. Slider_SpellSize_Range )
		sizeSlider:SetMinMaxValues( 0 , 100 )
		sizeSlider:SetValueStep( 1 )
		sizeSlider:SetValue( size )
		sizeSlider.changing = touchButtonSliderChanging
	end
	local touchButton = nil
	local touchID = nil
	local Count = nil
	-- spell
	for n = 1 , IDBiasPage do
		touchButton = getglobal( "ActionButton" .. n )
		TouchButtons[ n ] = touchButton 
		touchButton . touchBar = spell
		touchButton . Circle = getglobal( "touch" .. n .. "Circle" )
		touchButton . HotKey = getglobal( "ActionButton" .. n .. "HotKey" )
		Count = getglobal( "ActionButton" .. n .. "Count" )
		touchButton . Count = Count 
		touchButton . Name = getglobal( "ActionButton" .. n .. "Name" )
		touchButton . Cooldown = getglobal( "ActionButton" .. n .. "Cooldown" )
		touchButton . NormalTexture = getglobal( "ActionButton" .. n .. "NormalTexture" )

		Count : ClearAllPoints()
		Count : SetPoint( "LEFT" , 5 , 0 )
		touchButton : SetParent( UIParent )
		touchButton : SetClampedToScreen( true )
		touchButton : SetMovable( true )
		touchButton : EnableMouse( true )
		touchButton : RegisterForDrag( "LeftButton" )
		touchButton : SetScript( "OnDragStart" , touchButtonDraging )
		touchButton : SetScript( "OnDragStop" , DragStop_Frame)
		touchButton : SetScript( "OnMouseUp" , MouseUp_Frame )
		touchControl = getglobal( TouchControl .. n )
		touchControl : ClearAllPoints()
		touchControl : SetPoint( "TOPLEFT" , "ActionButton" .. n , "TOPRIGHT", -50 , -50 )
		touchButtonSetSize( touchButton , touchPlay_Saved[ n ] , spell )
	end
	-- page
	for n = 1 , HowManyPages do
		touchID = n + IDBiasPage --TouchButtonsID_Increase 
		touchButton = getglobal( "touchButton" .. n )
		touchButton . touchBar = page
		touchButton : SetScript( "OnClick" , switchTouchBar )
		touchButton : SetScript( "OnDragStart" , DragStart_touchButton )
		touchButton : SetScript( "OnDragStop" , DragStop_Frame)
		touchButton : SetScript( "OnMouseUp" , MouseUp_Frame )
		touchControl = getglobal( TouchControl .. touchID )
		touchControl : ClearAllPoints()
		touchControl : SetPoint( "TOPRIGHT" , "touchButton" .. n , "TOPLEFT" , -20 , 0 )
		touchButtonSetSize( touchButton , touchPlay_Saved[ touchID ] , page )
	end
	-- port
	local blizFrames = {
				CharacterMicroButton ,--1
				SpellbookMicroButton ,--2
				TalentMicroButton ,--3
				QuestLogMicroButton ,--4
				SocialsMicroButton ,--5
				WorldMapMicroButton ,--6
				MainMenuMicroButton ,--7
				HelpMicroButton ,--8
				MainMenuBarBackpackButton ,--9
				CharacterBag0Slot ,--10
				CharacterBag1Slot ,--11
				CharacterBag2Slot ,--12
				CharacterBag3Slot ,--13
				KeyRingButton --14
				}
	for n , touchButton in ipairs( blizFrames ) do
		touchID = n + IDBiasPort  --TouchButtonsID_Increase 
		TouchButtons[ touchID ] = touchButton 
		if n < 9 then
			touchButton : SetID( touchID )
			touchButton . touchBar = port
			touchButton : RegisterForDrag( "LeftButton" )
			touchButton : SetParent( UIParent )
			touchButton : SetClampedToScreen( true )
			touchButton : SetMovable( true )
			touchButton : EnableMouse( true )
			touchButton : SetScript( "OnDragStart" , DragStart_touchButton )
			touchButton : SetScript( "OnDragStop" , DragStop_Frame )
			touchButton : SetScript( "OnMouseUp" , MouseUp_Frame )
			touchButtonSetSize( touchButton , touchPlay_Saved[ touchID ] , port , touchID )
		else
			touchButton . touchBar = bag
			touchButton : RegisterForDrag( "LeftButton" )
			touchButton : SetParent( UIParent )
			touchButton : SetClampedToScreen( true )
			touchButton : SetMovable( true )
			touchButton : EnableMouse( true )
			if n == 9 then
				touchButton . NormalTexture = MainMenuBarBackpackButtonNormalTexture
				touchButton : SetScript( "OnReceiveDrag" , 
					function() 
						if IsAltKeyDown() or IsControlKeyDown() then
						else
							BackpackButton_OnClick();
						end
					end
				)
			elseif n < 14 then
				touchButton . NormalTexture = getglobal( "CharacterBag" .. n -10 .. "Slot" .. "NormalTexture" )
				touchButton : SetScript( "OnReceiveDrag" , 
					function() 
						if IsAltKeyDown() or IsControlKeyDown() then
						else
							BagSlotButton_OnClick();
						end
					end
				)
			end
			touchButton . TouchID = touchID 
			touchButton : SetScript( "OnDragStart" , DragStart_bagButton )
			touchButton : SetScript( "OnDragStop" , DragStop_Frame )
			touchButton : SetScript( "OnMouseUp" , MouseUp_Frame )
			touchButtonSetSize( touchButton , touchPlay_Saved[ touchID ] , bag )
		end
		touchControl = getglobal( TouchControl .. touchID )
		touchControl : ClearAllPoints()
		touchControl : SetPoint( "TOPLEFT" , touchButton , "TOPRIGHT", -50 , -50 )
	end
	-- buff
	for n = 0 , 23 do
		touchID = n + IDBiasBuff --TouchButtonsID_Increase 
		touchButton = getglobal( "BuffButton" .. n )
		TouchButtons[ touchID ] = touchButton 
		touchButton . TouchID = touchID 
		touchButton : SetClampedToScreen( true )
		touchButton : SetMovable( true )
		touchButton : EnableMouse( true )
		touchButton : RegisterForDrag( "LeftButton" )
		touchButton : SetScript( "OnDragStart" , DragStart_touchButton )
		touchButton : SetScript( "OnDragStop" , DragStop_Frame )
		touchButton : SetScript( "OnMouseUp" , MouseUp_Frame )
		touchControl = getglobal( TouchControl .. touchID )
		touchControl : ClearAllPoints()
		touchControl : SetPoint( "TOPLEFT" , "BuffButton" .. n , "TOPRIGHT", -50 , -50 )
		if n < 16 then
			touchButton . touchBar = buff 
			touchButtonSetSize( touchButton , touchPlay_Saved[ touchID ] , buff )
		else
			touchButton . touchBar = debuff 
			touchButtonSetSize( touchButton , touchPlay_Saved[ touchID ] , debuff )
		end
	end
	-- pet
	for n = 1 , 10 do
		touchID = n + IDBiasPet  --TouchButtonsID_Increase 
		touchButton = getglobal( "PetActionButton" .. n )
		TouchButtons[ touchID ] = touchButton 
		touchButton . touchBar = pet
		touchButton . AutoCastable = getglobal( "PetActionButton" .. n .. "AutoCastable" )
		touchButton . AutoCast = getglobal( "PetActionButton" .. n .. "AutoCast" )
		touchButton . HotKey = getglobal( "PetActionButton" .. n .. "HotKey" )
		Count = getglobal( "PetActionButton" .. n .. "Count" )
		touchButton . Count = Count 
		touchButton . Name = getglobal( "PetActionButton" .. n .. "Name" )
		touchButton . Cooldown = getglobal( "PetActionButton" .. n .. "Cooldown" )
		touchButton . NormalTexture2 = getglobal( "PetActionButton" .. n .. "NormalTexture2" )

		Count : ClearAllPoints()
		Count : SetPoint( "LEFT" , 5 , 0 )

		touchButton : SetParent( UIParent )
		touchButton : SetClampedToScreen( true )
		touchButton : SetMovable( true )
		touchButton : EnableMouse( true )
		touchButton : RegisterForDrag( "LeftButton" )
		touchButton : SetScript( "OnDragStart" , DragStart_petButton )
		touchButton : SetScript( "OnDragStop" , DragStop_Frame )
		touchButton : SetScript( "OnReceiveDrag" , ReceiveDrag_petButton )
		touchButton : SetScript( "OnMouseUp" , MouseUp_Frame )
		touchControl = getglobal( TouchControl .. touchID )
		touchControl : ClearAllPoints()
		touchControl : SetPoint( "TOPLEFT" , "PetActionButton" .. n , "TOPRIGHT", -50 , -50 )
		touchButtonSetSize( touchButton , touchPlay_Saved[ touchID ] , pet )
	end
	-- ShapeshiftButton
	if touchUnitClass == touchWarrior or touchUnitClass == touchPaladin or touchUnitClass == touchRogue or touchUnitClass == touchDruid then
		for n = 1 , HowManyShapeshifts do
			touchID = n + IDBiasShapeshift  -- TouchButtonsID_Increase 
			touchButton = getglobal( "ShapeshiftButton" .. n )
			TouchButtons[ touchID ] = touchButton 
			touchButton . touchBar = shift
			touchButton . HotKey = getglobal( "ShapeshiftButton" .. n .. "HotKey" )
			Count = getglobal( "ShapeshiftButton" .. n .. "Count" )
			touchButton . Count = Count 
			touchButton . Name = getglobal( "ShapeshiftButton" .. n .. "Name" )
			touchButton . Cooldown = getglobal( "ShapeshiftButton" .. n .. "Cooldown" )
			touchButton . NormalTexture = getglobal( "ShapeshiftButton" .. n .. "NormalTexture" )

			Count : ClearAllPoints()
			Count : SetPoint( "LEFT" , 5 , 0 )
			touchButton : SetParent( UIParent )
			touchButton : SetClampedToScreen( true )
			touchButton : SetMovable( true )
			touchButton : EnableMouse( true )
			touchButton : RegisterForDrag( "LeftButton" )
			touchButton : SetScript( "OnDragStart" , DragStart_touchButton )
			touchButton : SetScript( "OnDragStop" , DragStop_Frame )
			touchButton : SetScript( "OnMouseUp" , MouseUp_Frame )
			touchControl = getglobal( TouchControl .. touchID )
			touchControl : ClearAllPoints()
			touchControl : SetPoint( "TOPLEFT" , "ShapeshiftButton" .. n , "TOPRIGHT", -50 , -50 )
		end
		ShapeshiftButton1 : SetScript( "OnUpdate" , updateShapeshiftButton )
		ShapeshiftButton1 : RegisterEvent( "WORLD_MAP_UPDATE" )
		ShapeshiftButton1 : RegisterEvent( "ZONE_CHANGED" )
		ShapeshiftButton1 : RegisterEvent( "ZONE_CHANGED_NEW_AREA" )
		ShapeshiftButton1 : RegisterEvent( "PLAYER_LEVEL_UP" )
		ShapeshiftButton1 : SetScript( "OnEvent" , 
			function()
				if event == "ZONE_CHANGED" or event == "ZONE_CHANGED_NEW_AREA" or event == "PLAYER_LEVEL_UP" or event == "WORLD_MAP_UPDATE" then
					this : SetScript( "OnUpdate" , updateShapeshiftButton )
				end
			end 
		)
	end
	local touchFrames = {
			touchPlayerFrame , --1
			touchTargetFrame ,--2
			touchMinimapFrame ,--3
			touchStateFrame , --4
			touchTooltipFrame , --5
			touchCharacterFrame , --6
			touchBookFrame , --7
			touchTalentFrame , --8
			touchQuestLogFrame , --9
			touchQuestFrame , --10
			touchFriendsFrame , --11
			touchTrainerFrame , --12
			touchMailFrame , --13
			touchMerchantFrame , --14
			touchBattlefieldFrame , --15
			touchStableFrame , -- 16
			touchTradeFrame , --17
			touchTradeSkillFrame , --18
			touchCraftFrame , --19
			touchInspectFrame , --20
			touchAuctionFrame , --21
			touchGossipFrame , --22
			touchRegistrarFrame , --23
			touchTabardFrame , --24
			touchDressUpFrame , --25
			touchTaxiFrame , --26
			touchMacroFrame , --27
			touchBankFrame , --28
			touchContainerFrame1 , --29
			touchContainerFrame2 , --30
			touchContainerFrame3 , --31
			touchContainerFrame4 , --32
			touchContainerFrame5 , --33
			touchContainerFrame6 , --34
			touchContainerFrame7 , --35
			touchContainerFrame8 , --36
			touchContainerFrame9 , --37
			touchContainerFrame10 , --38
			touchContainerFrame11 , --39
			touchContainerFrame12 , --40
			}
	blizFrames = {
			PlayerFrame , --1
			TargetFrame , --2
			MinimapCluster , --3
			WorldStateAlwaysUpFrame , --4
			GameTooltip ,--5
			CharacterFrame ,--6
			SpellBookFrame , --7
			TalentFrame , --8
			QuestLogFrame , --9
			QuestFrame , --10
			FriendsFrame , --11
			ClassTrainerFrame , --12
			MailFrame , --13
			MerchantFrame , --14
			BattlefieldFrame ,--15
			PetStableFrame , -- 16
			TradeFrame , --17
			TradeSkillFrame , --18
			CraftFrame ,--19
			InspectFrame , --20
			AuctionFrame , --21
			GossipFrame , -- 22
			GuildRegistrarFrame , --23
			TabardFrame , --24
			DressUpFrame , --25
			TaxiFrame , --26
			MacroFrame , --27
			BankFrame , --28
			ContainerFrame1 , -- 29
			ContainerFrame2 ,--30
			ContainerFrame3 ,--31
			ContainerFrame4 ,--32
			ContainerFrame5 ,--33
			ContainerFrame6 ,--34
			ContainerFrame7 ,--35
			ContainerFrame8 ,--36
			ContainerFrame9 ,--37
			ContainerFrame10 ,--38
			ContainerFrame11 , --39
			ContainerFrame12 , --40
			}
	size = 40
	for n = 1 , size do
		touchButton = blizFrames[ n ] 
		touchButton . touchFrame = touchFrames[ n ] 
		if n ~= 6 then
			if n == 5 then
				touchButton : EnableMouse( true )
				touchButton : SetClampedToScreen( true )
			end
			touchButton : RegisterForDrag( "LeftButton" )
			touchButton : SetScript( "OnDragStart" , touchFrameShowHide )
		end
		if n > 4 and n ~= 12 then
			touchButton : SetScript( "OnShow" , touchFrameOnShow )
		end
	end
	for n = 1 , size do
		touchButton = touchFrames[ n ] 
		touchButton . Movee = blizFrames[ n ] 
		if n == 1 then
			touchButton . Movee0 = MainMenuBarPerformanceBarFrame 
		end
		touchButton : RegisterForDrag( "LeftButton" )
		touchButton : SetScript( "OnDragStart" , DragStart_Frame )
		touchButton : SetScript( "OnDragStop" , touchFrameStop )
		touchButton : SetScript( "OnMouseUp" , MouseUp_Frame )
	end
	PaperDollFrame . touchFrame = touchCharacterFrame 
	PaperDollFrame : RegisterForDrag( "LeftButton" )
	PaperDollFrame : SetScript( "OnDragStart" , touchFrameShowHide )
	size = 0
	MainMenuBar : SetScript( "OnUpdate" , 
		function()
			size = size + 1
			if size == 3 then
				PlayerFrame : ClearAllPoints()
				PlayerFrame : SetPoint( "CENTER" , touchPlayerFrame , "CENTER" , 0 , 0 ) 
				MainMenuBarPerformanceBarFrame : ClearAllPoints()
				MainMenuBarPerformanceBarFrame : SetPoint( "LEFT" , touchPlayerFrame , "LEFT" , 15 , 0 )
				TargetFrame : ClearAllPoints()
				TargetFrame : SetPoint( "CENTER" , touchTargetFrame , "CENTER" , 0 , 0 ) 
				MinimapCluster : ClearAllPoints()
				MinimapCluster : SetPoint( "CENTER" , touchMinimapFrame , "CENTER" , 0 , 0 ) 
				WorldStateAlwaysUpFrame : SetWidth( 100 )
				WorldStateAlwaysUpFrame : SetHeight( 70 ) 
				WorldStateAlwaysUpFrame : ClearAllPoints()
				WorldStateAlwaysUpFrame : SetPoint( "CENTER" , touchStateFrame , "CENTER" , 0 , 0 ) 
				--ReputationWatchBar : ClearAllPoints()
				ReputationWatchStatusBar : ClearAllPoints()
				local level = UnitLevel("player")
				if level ~= 60 then
					--ReputationWatchBar : SetPoint( "BOTTOM" , 0 , -36 )
					ReputationWatchStatusBar : SetPoint( "BOTTOM" , 0 , -36 )
				else
					--ReputationWatchBar : SetPoint( "TOP" , 0 , -41.277 )
					ReputationWatchStatusBar : SetPoint( "BOTTOM" , 0 , -41.277 )
				end
				MainMenuBar : SetScript( "OnUpdate" , updateFukFrame )
			end
		end
	)
	ReputationDetailMainScreenCheckBox : SetScript( "OnLeave" , 
		function()
			local touchUnitClass = UnitClass("player")
			if touchUnitClass == touchWarrior or touchUnitClass == touchPaladin or touchUnitClass == touchRogue or touchUnitClass == touchDruid then
				for n = 1 , HowManyShapeshifts do
					touchButtonSetSize( TouchButtons[ n + IDBiasShapeshift ] , touchPlay_Saved[ n + IDBiasShapeshift ] , shift )
				end
			end
		end 
	)
	CastingBarFrame : SetClampedToScreen( true )
	CastingBarFrame : SetMovable( true )
	CastingBarFrame : EnableMouse( true )
	CastingBarFrame : RegisterForDrag( "LeftButton" )
	CastingBarFrame : SetScript( "OnDragStart" , 
		function()
			if IsAltKeyDown() then
				this : StartMoving();
				this . isMoving = true;
			end
		end
	)
	CastingBarFrame : SetScript( "OnDragStop" , DragStop_Frame )
	CastingBarFrame : SetScript( "OnMouseUp" , MouseUp_Frame )
	MainMenuBarMaxLevelBar : SetAlpha( 0 )
	ReputationWatchBar : SetFrameStrata( "BACKGROUND" )
	MainMenuBarPerformanceBarFrame : SetFrameStrata( "LOW" )
	MainMenuExpBar : SetFrameStrata( "BACKGROUND" )
	PetActionBarFrame : SetParent( MainMenuBarArtFrame )
	BonusActionBarFrame : SetParent( MainMenuBarArtFrame )
	MultiBarBottomLeft : SetParent( MainMenuBarArtFrame )
	MultiBarBottomRight : SetParent( MainMenuBarArtFrame )
	MultiBarRight : SetParent( MainMenuBarArtFrame )
	MultiBarLeft : SetParent( MainMenuBarArtFrame )
	ShapeshiftBarFrame : SetParent( MainMenuBarArtFrame )
	MainMenuBarArtFrame : SetParent( UIParent )
	MainMenuBarArtFrame : Hide()
	MainMenuExpBar : ClearAllPoints()
	MainMenuExpBar : SetPoint( "BOTTOM" , UIParent , 0 , 0 )
	MainMenuBar : EnableMouse( false )
end